/* DEMO.C : Test Graphics Package. */
#include <stdio.h>
#include <math.h>

static  int i, n, N=101;
static  double x, y, L = 350.0, fx[351];

main()
{

    info();
    for ( i = 0 ; i < 351 ; i++ )
        fx[i] = 0.0;
    GINIT('l');
    GWINDOW(0.0, -150.0, L, 150.0);
    for (n = 1 ; n <= N ; n+=2) {      /* Odd values for n */
        GCLEAR();
        GVIEW(0,100,319,199);
        GCOLOR(1);
        GPLOT(0.0,0.0);
        GDRAW(0.0,100.0);
        GDRAW(L,100.0);
        GDRAW(L,0.0);
        for ( x = 0.0 ; x <= L ; x += 1.0 ) {
            GVIEW(0,0,319,99);
            y = ( 400.0 / ( (double)n * 3.14159 ) ) * sin( (double)n *
                    3.14159 * x / L );
            GCOLOR(2);
            GPLOT(x,y);
            GVIEW(0,100,319,199);
            GCOLOR(3);
            GPLOT(x, (fx[ (int)x ] += y) );
        }
    }
}

info()
{
    char    c;

    printf("\n\n");
    printf("\nThis program will plot the Fourier Sine series for the");
    printf("\nfunction f(x)=100 for 0 <= x <= L.  The individual parts");
    printf("\nwill be plotted on the upper half of the screen and the");
    printf("\ntotal approximation will be plotted on the bottom half");
    printf("\nof the screen.");
    printf("\n\n\n\nPRESS RETURN.....");
    c = getchar();
    return;
}





