/* Structure returned by _GETDPB. This is the DPB returned by 
DOS, with some things dropped out. Assumptions: char == 8 bits,
int == 16 bits. */

#define DIRSTRLEN 64		/* Max length in bytes of directory strings */

struct _dpb {
 int sector_size;		/* Size of physical sector in bytes */
 int secs_clust;		/* sectors/cluster, */
 int first_FAT;			/* Starting record of FATs */
 int FAT_count;			/* Number of FATs for this drive */
 int root_entries;		/* Number of directory entries */
 int first_sector;		/* First sector of first cluster */
 int max_cluster;		/* Number of clusters on drive + 1 */
 int FAT_size;			/* Number of records occupied by FAT */
 int dir_sector;		/* Starting record of directory */
 int media;			/* Media byte */
 int current_dir;		/* Cluster number of start of current directory
				   0 indicates root, -1 indicates invalid */
} dpb;
